//StylesNonUtilises_305f.js
// 16.09.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Des styles inutiliss sont supprims

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il faut ouvrir un document InDesign.", "Attention");
	exit();
}

// tester la version du programme
var appVers = app.version[0];
if (appVers != 5) {
	if (appVers == 4) {
		alert ("Avec InDesign CS2\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else if (appVers == 6) {
		alert ("Avec InDesign CS4\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else {
		alert ("Il ne faut utiliser ce script qu'avec InDesign CS3.", "Attention");
	}
	exit();
}

// une rfrence au document au premier plan
var curDoc = app.documents[0];

// vrifier la prsence de groupes de styles de paragraphes
paraGroups = curDoc.paragraphStyleGroups;
var nPSG = paraGroups.length;

// vrifier la prsence de groupes de styles de caractres
charGroups = curDoc.characterStyleGroups;
var nCSG = charGroups.length;

// vrifier la prsence de groupes de styles d'objets
objtGroups = curDoc.objectStyleGroups;
var nOSG = objtGroups.length;

// initialiser des variables
var noParaStyle = curDoc.paragraphStyles[0].name;
var dfParaStyle = curDoc.paragraphStyles[1].name;
var noCharStyle = curDoc.characterStyles[0].name;
var cCtr = 0;
var pCtr = 0;

// mmoriser les styles de paragraphes
var pStyles;
var ps00 = curDoc.paragraphStyles;
var psLists = new Array (ps00);
for (var i=0; i<nPSG; i++) {
	pStyles = curDoc.paragraphStyleGroups[i].paragraphStyles;
	psLists.push(pStyles);
}

// mmoriser les styles de caractres
var cStyles;
var cs00 = curDoc.characterStyles;
var csLists = new Array (cs00);
for (var i=0; i<nCSG; i++) {
	cStyles = curDoc.characterStyleGroups[i].characterStyles;
	csLists.push(cStyles);
}

// prparer les listes des groupes de styles de paragraphes
var pg00 = new Array ();
var pGroupLists = new Array (pg00);
for (var i=0; i<nPSG; i++) {
	pGroupLists.push(new Array ());
}

// prparer les listes des groupes de styles de caractres
var cg00 = new Array ();
var cGroupLists = new Array (cg00);
for (var i=0; i<nCSG; i++) {
	cGroupLists.push(new Array ());
}

// tablir la liste des styles de paragraphes qui sont utiliss 
// comme "D'aprs" et/ou "Style suivant"
var allParaStyles, nParaStyles;
var curProps, curPName, bas, basProps, bnm, par, pg, nxt, nxtProps, nnm;
for (var i=0; i<(nPSG+1); i++) {
	allParaStyles = psLists[i];
	nParaStyles = allParaStyles.length;
	for (var p=0; p<nParaStyles; p++) {
		curProps = allParaStyles[p].properties;
		curPName = curProps.name;
		try {
			bas = curProps.basedOn;
			basProps = bas.properties;
			bnm = basProps.name;
			if (bnm != undefined && bnm != dfParaStyle) {
				par = basProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (!isInArray(bnm, pGroupLists[pg])) {
					pGroupLists[pg].push(bnm);
				}
			}
		}
		catch (e) {
		}
		try {
			nxt = curProps.nextStyle;
			nxtProps = nxt.properties;
			nnm = nxtProps.name;
			if (nnm != undefined && nnm != dfParaStyle) {
				par = nxtProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (nnm == curPName && pg != i || nnm != curPName) {
					if (!isInArray(nnm, pGroupLists[pg])) {
						pGroupLists[pg].push(nnm);
					}
				}
			}
		}
		catch (e) {
		}
	}
}

// ajouter les styles de paragraphes qui sont utiliss dans les styles d'objets
var allObjectStyles;
var nObjStyles, obj, objProps, obn;
for (var i=0; i<(nOSG+1); i++) {
	if (i==0) {
		allObjectStyles = curDoc.objectStyles;
	}
	else {
		allObjectStyles = curDoc.objectStyleGroups[i-1].objectStyles;
	}
	nObjStyles = allObjectStyles.length;
	for (var o=0; o<nObjStyles; o++) {
		try {
			obj = allObjectStyles[o].appliedParagraphStyle;
			objProps = obj.properties;
			obn = objProps.name;
			if (obn != undefined && obn != noParaStyle && obn != dfParaStyle) {
				par = objProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (!isInArray(obn, pGroupLists[pg])) {
					pGroupLists[pg].push(obn);
				}
			}
		}
		catch (e) {
		}
	}
}

// ajouter les noms des styles de paragraphes utiliss dans le document aux listes
var allStories = curDoc.stories;
var nStories = allStories.length;
var allStyles, nStyles, curStyle, cnm;
for (var i=0; i<nStories; i++) {
	if (allStories[i].length >0) {
		try {
			allStyles = allStories[i].paragraphs.everyItem().appliedParagraphStyle;
			nStyles = allStyles.length;
			for (var s=0; s<nStyles; s++) {
				curStyle = allStyles[s];
				curProps = curStyle.properties;
				cnm = curProps.name;
				if (cnm != noParaStyle && cnm != dfParaStyle) {
					par = curProps.parent;
					if (par == "[object Document]") {
						pg = 0;
					}
					else {
						pg = (par.index) + 1;
					}
					if (!isInArray(cnm, pGroupLists[pg])) {
						pGroupLists[pg].push(cnm);
					}
				}
			}
		}
		catch (e) {
		}
	}
	else {
		try {
			curStyle = allStories[i].insertionPoints[0].appliedParagraphStyle;
			curProps = curStyle.properties;
			cnm = curProps.name;
			if (cnm != noParaStyle && cnm != dfParaStyle) {
				par = curProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (!isInArray(cnm, pGroupLists[pg])) {
					pGroupLists[pg].push(cnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// les styles de paragraphes appliqus dans des tableaux
try {
	var tabPStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = tabPStyles.length;
	for (var t=0; t<nStyles; t++) {
		curStyle = tabPStyles[t];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noParaStyle && cnm != dfParaStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				pg = 0;
			}
			else {
				pg = (par.index) + 1;
			}
			if (!isInArray(cnm, pGroupLists[pg])) {
				pGroupLists[pg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// les styles de paragraphes appliqus dans des notes
try {
	var footPStyles = allStories.everyItem().footnotes.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = footPStyles.length;
	for (var f=0; f<nStyles; f++) {
		curStyle = footPStyles[f];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noParaStyle && cnm != dfParaStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				pg = 0;
			}
			else {
				pg = (par.index) + 1;
			}
			if (!isInArray(cnm, pGroupLists[pg])) {
				pGroupLists[pg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// une boucle  travers les styles de paragraphes; supprimer le style courant
// s'il ne se trouve pas dans la liste "styles utiliss"
var allParaNames;
for (var i=0; i<(nPSG+1); i++) {
	allParaStyles = psLists[i];
	allParaNames = allParaStyles.everyItem().name;
	nParaStyles = allParaStyles.length;
	for (var p=nParaStyles-1; p>-1; p--) {
		curPName = allParaNames[p];
		if (!isInArray(curPName, pGroupLists[i])) {
			try {
				if (i==0) {
					curDoc.paragraphStyles[p].remove();
					pCtr++;
				}
				else {
					curDoc.paragraphStyleGroups[i-1].paragraphStyles[p].remove();
					pCtr++;
				}
			}
			catch (e) {
			}
		}
	}
}

// tablir la liste des styles de caractres qui sont utiliss comme "D'aprs"
var allCharStyles, nCharStyles;
var curCName, cg;
for (var i=0; i<(nCSG+1); i++) {
	allCharStyles = csLists[i];
	var nCharStyles = allCharStyles.length;
	for (var c=0; c<nCharStyles; c++) {
		curProps = allCharStyles[c].properties;
		curCName = curProps.name;
		try {
			bas = curProps.basedOn;
			basProps = bas.properties;
			bnm = basProps.name;
			if (bnm != undefined && bnm != noCharStyle) {
				par = basProps.parent;
				if (par == "[object Document]") {
					cg = 0;
				}
				else {
					cg = (par.index) + 1;
				}
				if (!isInArray(bnm, cGroupLists[cg])) {
					cGroupLists[cg].push(bnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// ajouter les styles de caractres qui sont utiliss comme lettrines 
// et/ou dans les styles imbriqus
// et/ou pour les numrations
var allNes, nes, nesProps, bcs, bcsProps;
for (var i=0; i<(nPSG+1); i++) {
	if (i==0) {
		allParaStyles = curDoc.paragraphStyles;
	}
	else {
		allParaStyles = curDoc.paragraphStyleGroups[i-1].paragraphStyles;
	}
	var nParaStyles = allParaStyles.length;
	for (var p=0; p<nParaStyles; p++) {
		allNes = allParaStyles[p].nestedStyles;
		nStyles = allNes.length;
		for (var n=0; n<nStyles; n++) {
			try {
				nes = allNes[n].appliedCharacterStyle;
				nesProps = nes.properties;
				nnm = nesProps.name;
				if (nnm != noCharStyle) {
					par = nesProps.parent;
					if (par == "[object Document]") {
						cg = 0;
					}
					else {
						cg = (par.index) + 1;
					}
					if (!isInArray(nnm, cGroupLists[cg])) {
						cGroupLists[cg].push(nnm);
					}
				}
			}
			catch (e) {
			}
		}
		try {
			bcs = allParaStyles[p].bulletsCharacterStyle;
			bcsProps = bcs.properties;
			bnm = bcsProps.name;
			if (bnm != noCharStyle) {
				par = bcsProps.parent;
				if (par == "[object Document]") {
					cg = 0;
				}
				else {
					cg = (par.index) + 1;
				}
				if (!isInArray(bnm, cGroupLists[cg])) {
					cGroupLists[cg].push(bnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// puis, les noms des styles de caractres appliqus dans le document
for (var i=0; i<nStories; i++) {
	if (allStories[i].length >0) {
		try {
			allCharStyles = allStories[i].textStyleRanges.everyItem().appliedCharacterStyle;
			nStyles = allCharStyles.length;
			for (var s=0; s<nStyles; s++) {
				curStyle = allCharStyles[s];
				curProps = curStyle.properties;
				cnm = curProps.name;
				if (cnm != noCharStyle) {
					par = curProps.parent;
					if (par == "[object Document]") {
						cg = 0;
					}
					else {
						cg = (par.index) + 1;
					}
					if (!isInArray(cnm, cGroupLists[cg])) {
						cGroupLists[cg].push(cnm);
					}
				}
			}
		}
		catch (e) {
		}
	}
	else {
		try {
			curStyle = allStories[i].insertionPoints[0].appliedCharacterStyle;
			curProps = curStyle.properties;
			cnm = curProps.name;
			if (cnm != noCharStyle) {
				par = curProps.parent;
				if (par == "[object Document]") {
					cg = 0;
				}
				else {
					cg = (par.index) + 1;
				}
				if (!isInArray(cnm, cGroupLists[cg])) {
					cGroupLists[cg].push(cnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// les styles de caractres appliqus dans des tableaux
try {
	var tabCStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = tabCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curStyle = tabCStyles[s];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noCharStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				cg = 0;
			}
			else {
				cg = (par.index) + 1;
			}
			if (!isInArray(cnm, cGroupLists[cg])) {
				cGroupLists[cg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// les styles de caractres appliqus dans des notes
try {
	var footCStyles = allStories.everyItem().footnotes.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = footCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curStyle = footCStyles[s];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noCharStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				cg = 0;
			}
			else {
				cg = (par.index) + 1;
			}
			if (!isInArray(cnm, cGroupLists[cg])) {
				cGroupLists[cg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// une boucle  travers les styles de caractres; supprimer le style courant
// s'il ne se trouve pas dans la liste "styles utiliss"
var allCharNames;
for (var i=0; i<(nCSG+1); i++) {
	allCharStyles = csLists[i];
	allCharNames = allCharStyles.everyItem().name;
	nCharStyles = allCharStyles.length;
	for (var c=nCharStyles-1; c>-1; c--) {
		curName = allCharNames[c];
		if (!isInArray(curName, cGroupLists[i])) {
			try {
				if (i==0) {
					curDoc.characterStyles[c].remove();
					cCtr++;
				}
				else {
					curDoc.characterStyleGroups[i-1].characterStyles[c].remove();
					cCtr++;
				}
			}
			catch (e) {
			}
		}
	}
}

// supprimer des dossiers de styles de paragraphes vides
for (var p=nPSG-1; p>-1; p--) {
	var nGroups = paraGroups[p].paragraphStyleGroups.length;
	if (nGroups > 0) {
		continue;
	}
	var nStyles = paraGroups[p].paragraphStyles.length;
	if (nStyles == 0) {
		paraGroups[p].remove();
	}
}

// supprimer des dossiers de styles de caractres vides
for (var c=nCSG-1; c>-1; c--) {
	var nGroups = charGroups[c].characterStyleGroups.length;
	if (nGroups > 0) {
		continue;
	}
	var nStyles = charGroups[c].characterStyles.length;
	if (nStyles == 0) {
		charGroups[c].remove();
	}
}

// informer l'utilisateur
var totCtr = pCtr + cCtr;
if (totCtr == 0) {
	alert ("Aucun style supprim.", "Termin");
}
else {
	if (totCtr == 1) {
		if (pCtr == 1) {
			alert ("Un seul style de paragraphe a t supprim.", "Termin");
		}
		else {
			alert ("Un seul style de caractres a t supprim.", "Termin");
		}
	}
	else {
		alert ("Nombre de styles supprims:  " + totCtr + "\n\nStyles de paragraphes:\t" + pCtr + "\nStyles de caractres:\t\t" + cCtr, "Termin");
	}
}

// la fonction utilise pour tester si l'lment actuel se trouve dans une liste
function isInArray(curName, curArray) {
	for (var a=0; a<curArray.length; a++) {
		if(curArray[a] == curName) {
			return true;
		}
	}
	return false;
}